// Get the backend component
var javaComponent = Components.classes["@jsug.tuwien.at/je-backend;1"]
      .getService(Components.interfaces.nsISupports);

function init() {
  groupbox = document.getElementById("groupbox");
  menupopup = document.getElementById("categoryMenupopup");
  menulist = document.getElementById("categoryMenulist");
  textbox = document.getElementById("categoryTextbox");
  nameTextbox = document.getElementById("nameTextbox");
  urlTextbox = document.getElementById("urlTextbox");
  radiogroup = document.getElementById("radiogroup");
  radiogroup.addEventListener("select", updateState, true);
  
   // Change appearance of the dialog according to button clicked before
  if (!window.arguments[0].edit) {
    groupbox.hidden = false;
  } else {
    groupbox.hidden = true;
    nameTextbox.value = window.arguments[0].wsName;
    urlTextbox.value = window.arguments[0].wsUrl;
  }
  
  fillMenulist();
}
      
/**
 * Fills the menulist with names of the ws categories.
 */      
function fillMenulist() {
  var wsCategories = window.arguments[0].categories;
  for (var i = 0; i < wsCategories.length; i++) {
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", wsCategories[i]);
    menupopup.appendChild(menuitem);
  }
  
  // Select the first item in the menu.
  menulist.selectedIndex = 0;
}

/**
 * Activates/deactivates elements according to the selection in radiogroup.
 */ 
function updateState() {
  var index = radiogroup.selectedIndex;
  if (index == 0) {
    menulist.disabled = false;
    textbox.disabled = true;
  } else {
    menulist.disabled = true;
    textbox.disabled = false;
  }
}

/**
 * Calls method for add or edit a webservice
 */ 
function performAction() {
  if (!window.arguments[0].edit) {
    return addService();
  } else {
    return editService();
  }
}

/**
 * Adds a webservice
 */ 
function addService() {
  var catName = "";
  var wsName = nameTextbox.value;
  var wsUrl = urlTextbox.value;
    
  if (menulist.disabled == false) {
    catName = menulist.selectedItem.getAttribute("label");
  } else {
    catName = textbox.value;
  }
  if (catName.replace(/^\s+|\s+$/g, '') == "" || wsName.replace(/^\s+|\s+$/g, '') == "" || wsUrl.replace(/^\s+|\s+$/g, '') == "") {
    alert("Name, URL and category has to be set.");
    return false;
  } else {
    javaComponent.wrappedJSObject.addService(catName, wsName, wsUrl);
    alert("Service added.");
    opener.refreshTree();    
  }
}

/**
 * Edits a webservice
 */ 
function editService() {
  var catName = window.arguments[0].catName;
  var wsName = nameTextbox.value;
  var wsUrl = urlTextbox.value;
  
  if (wsName.replace(/^\s+|\s+$/g, '') == "" || wsUrl.replace(/^\s+|\s+$/g, '') == "") {
    alert("Name and URL has to be set.");
    return false;
  } else {
    javaComponent.wrappedJSObject.deleteService(catName, window.arguments[0].wsName);
    javaComponent.wrappedJSObject.addService(catName, wsName, wsUrl);
    alert("Changes saved.");
    opener.refreshTree();    
  }  
}
      
