package backend;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

import backend.dictionary.DictChunker;
import backend.dictionary.xml.FoundEntity;

/**
 * Mokup(Test) Class to test the LingPipe Parser
 * 
 * @author berni
 * 
 */
public class StaticParser {

	public static void main(String[] args) {

		//read html file from file and pass to chunker
		StringBuffer buf = new StringBuffer();
		try {

			BufferedReader input = new BufferedReader(new FileReader(new File("text.txt")));
			try {
				String line = null; 

				while ((line = input.readLine()) != null) {
					buf.append(line);
					buf.append(System.getProperty("line.separator"));
				}
			} finally {
				input.close();
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		String text = buf.toString();

		BackendHandler bHandler = new BackendHandler();
		bHandler.init("dict.xml", "webservice.xml");
		
		
//		dcc.addEntity("test", "teeeeeest");
//		dcc.addEntity("aa", "aa");
//		
//		dcc.addRegexType("meintyp", "cc");
		
		//System.out.print(asdf);
		
		Date d = new Date();
		DictChunker dcc = new DictChunker();
		String asdf = dcc.parse(text, bHandler);

		
//		dcc.addEntity("test", "teeeeeest");
//		dcc.addEntity("aa", "aa");
//		
//		dcc.addRegexType("meintyp", "cc");
		
		//System.out.print(asdf);
		Date d2 = new Date();
		System.out.println("Startzeit: "+d.toString());
		System.out.println("Endzeit: "+d2.toString());

		
		Vector<FoundEntity> results = bHandler.getFoundEntities();
		Iterator<FoundEntity> itr = results.iterator();
		
		while (itr.hasNext()) {
			FoundEntity fe = itr.next();
			System.out.println("##########################");
			System.out.println("Entity: " + fe.getPhrase());
			System.out.println("Entity-Type: " + fe.getType());
			System.out.println("Start: " + fe.getStart());
			System.out.println("End: " + fe.getEnd());
		}
		
	}

}
